> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/zec/security-group/describesecuritygroups.md).

# DescribeSecurityGroups

## 1. API Description

This API (DescribeSecurityGroups) is used to query the security groups under the account. Filtering by security group ID, name, or whether it is the default security group, as well as pagination, are supported.

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name    | Required | Type            | Description                                                                                                                              |
| ----------------- | -------- | --------------- | ---------------------------------------------------------------------------------------------------------------------------------------- |
| securityGroupIds  | No       | Array of String | <p>The security group ID.</p><p>Values can consist of multiple security group IDs. The maximum number of IDs in each request is 100.</p> |
| securityGroupName | No       | String          | Security group name.                                                                                                                     |
| isDefault         | No       | Boolean         | <p>Filter by whether it is the default security group.</p><p>If not specified, no filtering is applied.</p>                              |
| pageSize          | No       | Integer         | <p>Number of items in the current page result.</p><p>Default value: 20 ;</p><p>Maximum value: 1000 .</p><p>Default value: 20</p>         |
| pageNum           | No       | Integer         | <p>Number of pages returned.</p><p>Default value: 1 .</p><p>Default value: 1</p>                                                         |

## 3. Output Parameters

| Parameter Name | Type                                                                                                                 | Description                                                                                                           |
| -------------- | -------------------------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String                                                                                                               | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| totalCount     | Integer                                                                                                              | Number of security groups meeting the filtering conditions.                                                           |
| dataSet        | Array of [SecurityGroupInfo](https://docs.console.zenlayer.com/api-reference/zec/datastructure.md#securitygroupinfo) | Information on security groups.                                                                                       |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**1. Query the security group list.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DescribeSecurityGroups
<Common Request Params>

Request:
{
  "securityGroupIds": [],
  "securityGroupName": "",
  "pageSize": 5,
  "pageNum": 1
}

Response:
{
  "requestId": "T4237F94B-6A3B-4BD6-A9D5-398F4A049714",
  "response": {
      "requestId": "T4237F94B-6A3B-4BD6-A9D5-398F4A049714",
      "totalCount": 1,
      "dataSet": [
          {
              "securityGroupId": "<securityGroupId>",
              "securityGroupName": "Default-Security-Group",
              "isDefault": true,
              "nicIdList": ["xxx"],
              "createTime": "2024-08-14T02:31:57Z",
              "scope": "Global",
              "natIdList": ["xxx"],
              "vpcIds": ["xxx"],
              "loadBalancerIdList": ["xxx"],
              "haVipIdList": ["havip-xxxxxxxx"]
          }
      ]
  }
}
```

**2. Query only non-default security groups to get the count.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DescribeSecurityGroups
<Common Request Params>

Request:
{
  "isDefault": false,
  "pageSize": 1,
  "pageNum": 1
}

Response:
{
  "requestId": "T4237F94B-6A3B-4BD6-A9D5-398F4A049714",
  "response": {
      "requestId": "T4237F94B-6A3B-4BD6-A9D5-398F4A049714",
      "totalCount": 3,
      "dataSet": [
          {
              "securityGroupId": "<securityGroupId>",
              "securityGroupName": "web-sg",
              "isDefault": false,
              "nicIdList": [],
              "createTime": "2024-08-14T02:31:57Z",
              "scope": "Global",
              "natIdList": [],
              "vpcIds": [],
              "loadBalancerIdList": [],
              "haVipIdList": []
          }
      ]
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](https://docs.console.zenlayer.com/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](https://docs.console.zenlayer.com/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code | Description |
| ---------------- | ---------- | ----------- |
